from .parser import Tokenizer

tokenizer = (Tokenizer(eof=None)
    .skip(r'#.*')
    .token('command0', r'POP|ADD|SUB|MULT|DIV|NOP|HALT|RET|EQ|NE|LT|GT|LE|GE|LODI|STOI|PRT|PRN|PRC')
    .token('command1', r'LIT|LOD(LOCAL)?|STO(LOCAL)?|AC')
    .token('call', r'CALL')
    .token('jmpcommand', r'JMP|JMC')
    .token('identifier', r'[a-zA-Z][a-zA-Z0-9_]*')
    #.token('negative_number', r'-[1-9][0-9]*')
    .token('number', r'0|-?[1-9][0-9]*')
    .token('newline', r'\r?\n')
    .token('colon', r':')
    .token('semicolon', r';')
    .token('comma', r',')
    .token('openingBracket', r'\[')
    .token('closingBracket', r'\]')
    .token('assignment', r'/')
    .token('openingParenthesis', r'\(')
    .token('closingParenthesis', r'\)')
    .skip(r'\s+'))
